image:
  name: hashicorp/terraform:light
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

cache:
  paths:
    - .terraform

before_script:
  - cd module/
  - ls -lha
  - rm -rf .terraform
  - terraform --version
  - mkdir -p ./creds
  - echo $GCP_ACCOUNT_JSON > ./creds/serviceaccount.json
  - export TF_VAR_storage_name=${STORAGE_NAME}
  - export TF_VAR_location=${LOCATION}
  - export TF_VAR_storage_class=${STORAGE_CLASS}
  - export TF_VAR_project=${PROJECT}
  - export TF_VAR_region=${REGION}
  - terraform init -backend-config="bucket=${BUCKET_STATE}" -backend-config="credentials=./creds/serviceaccount.json"

stages:
  - validar
  - plan
  - apply
  - destroy

validar:
  stage: validar
  script:
    - terraform validate
  only:
    - branches

plan:
   stage: plan
   script:
     - terraform plan 
   dependencies:
     - validar

apply:
   stage: apply
   script:
     - ls -lha
     - terraform apply -auto-approve
   dependencies:
     - plan
   when: manual

destroy:
   stage: destroy
   script:
     - ls -lha
     - terraform destroy -auto-approve
   dependencies:
     - plan
   when: manual

# image:
#    name: hashicorp/terraform:light
#    entrypoint:
#      - '/usr/bin/env'
#      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

# before_script
#      -  cd gcs/
#      -  ls -lha
#      -  rm -rf .terraform
#      -  terraform --version
#      -  mkdir -p ./creds
#      -  echo $SERVICEACCOUNT | base64 -d > ./creds/serviceaccount.json
#      -  terraform init

# stages:
#       - validate
#       - plan
#       - apply

# validate:
#    stage: validate
#    script:
#      - terraform validate

# plan:
#    stage: plan
#    script:
#      - terraform plan -out "planfile"
#    dependencies:
#      - validate
#    artifacts:
#      paths:
#        - planfile

# apply:
#    stage: apply
#    script:
#      - terraform apply -input=false "planfile"
#    dependencies:
#      - plan
#    when: manual
